/*! © 2012 Korx Limited */
/*
---
name: Korx.Cycler

version: 0.4

description: Korx.Cycler is a versatile MooTools plugin which can be used to easily create a user interface control which cycles through elements, for example a slider, carousel or slideshow. It uses CSS 3 transitions with a fallback to Fx.Morph for older browsers, and there's plenty of options to configure it how you want and events to hook in to.

license: 
  - MIT-style

authors: 
  - Michael Bird <michael.bird@korx.com>

requires:
  - core/1.4:Core
  - core/1.4:Array
  - core/1.4:Function
  - core/1.4:Event
  - core/1.4:Class
  - core/1.4:Class.Extras
  - core/1.4:Element
  - core/1.4:Element.Style
  - core/1.4:Element.Event
  - core/1.4:Fx.Morph

provides: 
  - Korx.Cycler

...
*/
Element.implement({transition:function(d,e,c,b,f){if(typeOf(f)=="undefined"||f==null){f=false}if(this.retrieve("transitioning",false)){var a=this.retrieve("queue");if(!a){a=[]}a.push({self:d,options:e,origin:c,destination:b,useCss:f});this.store("queue",a)}else{this.store("transitioning",true);if(f&&c!=null){this.setPrefixedStyles({transitionProperty:"none"})}(function(){if(c!=null){this.setPrefixedStyles(c)}if(typeOf(e.onStart)=="function"){e.onStart.call(d,{element:this,options:e,origin:c,destination:b,useCss:f})}(function(){if(f){this.setPrefixedStyles({transitionProperty:"all",transitionDuration:e.duration+"ms",transitionTimingFunction:e.timingFunction})}var g=function(l){if(!f||l.target==this){if(f){this.removeTransitionEndEvent(g);this.setPrefixedStyles({transitionProperty:"none"})}this.store("transitioning",false);if(typeOf(e.onComplete)=="function"){e.onComplete.call(d,{element:this,options:e,origin:c,destination:b,useCss:f})}var j=this.retrieve("queue");if(typeOf(j)=="array"&&j.length>0){var k=j.shift();this.store("queue",j);this.transition(k.self,k.options,k.origin,k.destination,k.useCss)}}}.bind(this);if(f){this.addTransitionEndEvent(g);this.setPrefixedStyles(b)}else{var h=Object.clone(e);h.onStart=null;h.onCancel=null;h.onComplete=g;h.onChainComplete=null;var i=new Fx.Morph(this,h);i.start(b)}}).delay(10,this)}).delay(10,this)}return this},addTransitionEndEvent:function(a){["webkitTransitionEnd","MSTransitionEnd","oTransitionEnd","transitionend"].each(function(b){if(this.addEventListener){this.addEventListener(b,a,false)}else{this.attachEvent(b,a)}},this);return this},removeTransitionEndEvent:function(a){["webkitTransitionEnd","MSTransitionEnd","oTransitionEnd","transitionend"].each(function(b){if(this.removeEventListener){this.removeEventListener(b,a,false)}else{this.detachEvent(b,a)}},this);return this},setPrefixedStyles:function(b){for(var a in b){this.setPrefixedStyle(a,b[a])}return this},setPrefixedStyle:function(b,a){if((b.length>=10&&b.slice(0,10)=="transition")||(b.length>=9&&b.slice(0,9)=="transform")||(b.length>=11&&b.slice(0,11)=="perspective")){["-webkit-","-moz-","-ms-","-o-",""].each(function(c){this.setStyle(c+b.hyphenate(),a)},this)}else{this.setStyle(b,a)}return this},removePrefixedStyles:function(){return this.removePrefixedStyle(arguments)},removePrefixedStyle:function(){Array.flatten(arguments).each(function(a){this.setPrefixedStyle(a,null)},this);return this}});if(!window.Korx){window.Korx={}}Korx.Cycler=new Class({Implements:[Events,Options],options:{onInit:function(){this.addItems(this.element.getChildren())},onReady:function(){this.move(0);this.play()},onStep:function(){this.move(1)},onTap:function(a){this.pause()},onSwipe:function(a){this.pause();switch(a.direction){case"up":case"left":this.move(-1);break;case"down":case"right":this.move(1);break}},duration:5000,flutter:250,appear:{onStart:function(a){a.element.inject(this.element,"top")},duration:500,transition:"quad:in:out",timingFunction:"ease-in-out"},disappear:{onComplete:function(a){this.transitioning.erase(a.element);a.element.destroy()},duration:500,transition:"quad:in:out",timingFunction:"ease-in-out"},origin:{css:{},js:{}},current:{css:{},js:{}},destination:{css:{},js:{}},swipeTime:500,swipeDistance:50},initialize:function(c,b){this.setOptions(b);this.element=document.id(c);this.items=[];this.css=false;this.ready=false;this.current=0;this.queue=[];this.transitioning=[];this.cycling=false;this.stepper=null;this.fireEvent("init");this.element.addEvent("touchstart",function(k){var l=this.options.swipeDistance;if(screen.width&&screen.height&&window.innerWidth&&window.innerHeight){if(!window.orientation){window.orientation=0}switch(window.orientation){case 0:case 180:l=l*(window.innerWidth/screen.width);break;case 90:case -90:case 270:l=l*(window.innerHeight/screen.height);break}}var h=null;var f=null;if(k.touches){if(k.touches.length==1){h={x:k.touches[0].clientX,y:k.touches[0].clientY,t:new Date().getTime()}}}else{h={x:k.clientX,y:k.clientY,t:new Date().getTime()}}if(h!=null){var i=function(m){if(m.touches){if(m.touches.length==1){f={x:m.touches[0].clientX,y:m.touches[0].clientY,t:new Date().getTime()}}else{f=null}}else{f={x:m.clientX,y:m.clientY,t:new Date().getTime()}}if(h!=null&&f!=null&&f.t-h.t<this.options.swipeTime){m.preventDefault()}else{this.element.removeEvent("touchmove",i);this.element.removeEvent("touchend",g);this.element.removeEvent("touchcancel",j)}}.bind(this);this.element.addEvent("touchmove",i);var g=function(p){if(h!=null&&f!=null&&f.t-h.t<this.options.swipeTime){p.preventDefault();var n=f.x-h.x;var m=f.y-h.y;var o=null;if(n<-l&&-l<m<l){o="left"}else{if(n>l&&-l<m<l){o="right"}else{if(m<-l&&-l<n<l){o="up"}else{if(m>l&&-l<n<l){o="down"}}}}if(o!=null){this.fireEvent("swipe",{origin:h,destination:f,direction:o})}else{this.fireEvent("tap",{origin:h,destination:f})}}this.element.removeEvent("touchmove",i);this.element.removeEvent("touchend",g);this.element.removeEvent("touchcancel",j)}.bind(this);this.element.addEvent("touchend",g);var j=function(m){this.element.removeEvent("touchmove",i);this.element.removeEvent("touchend",g);this.element.removeEvent("touchcancel",j)}.bind(this);this.element.addEvent("touchcancel",j)}}.bind(this));var a=function(f){this.css=true}.bind(this);var d=new Element("div").setPrefixedStyles({display:"block",position:"absolute",top:-1,left:-1,width:1,height:1,transition:"top 1ms ease"}).addTransitionEndEvent(a).inject(document.id(document.body));(function(){d.setPrefixedStyle("top",-2);(function(){d.removeTransitionEndEvent(a).destroy();this.ready=true;this.fireEvent("ready")}).delay(50,this)}).delay(10,this)},useCss:function(){this.css=true;if(this.stepper!=null){this.stop().play()}else{this.stop()}return this},useJs:function(){this.css=false;if(this.stepper!=null){this.stop().play()}else{this.stop()}return this},addItems:function(){Array.flatten(arguments).each(function(a){a.dispose();this.clean(a);this.items.include(a)},this);return this},removeItems:function(){return $$(Array.flatten(arguments).map(function(a){this.items.erase(a);return a},this))},reset:function(){if(this.items.length<1||this.current>=this.items.length){return this}this.transitioning.each(function(a){a.destroy()});this.transitioning=[];this.queue.each(function(a){a.destroy()});this.queue=[];this.queue.push(this.items[this.current].clone(true,true).store("direction",0).inject(this.element,"top"));return this},clean:function(a){a.removePrefixedStyles(["transition-property","transition-duration","transition-timing-function"].append(Object.keys(this.options.origin.js)).append(Object.keys(this.options.origin.css)).append(Object.keys(this.options.current.js)).append(Object.keys(this.options.current.css)).append(Object.keys(this.options.destination.js)).append(Object.keys(this.options.destination.css)));return this},play:function(){if(!this.ready||this.items.length<1){return this}clearInterval(this.stepper);this.stepper=(function(){this.fireEvent("step")}).periodical(this.options.duration,this);this.fireEvent("play");return this},stop:function(){clearInterval(this.stepper);this.stepper=null;this.reset();this.fireEvent("stop");return this},pause:function(){clearInterval(this.stepper);this.stepper=null;this.fireEvent("pause");return this},move:function(c){if(!this.ready||this.items.length<1){return this}if(this.queue.length==0){if(c==0){this.queue.push(this.items[this.current].clone(true,true).store("direction",1));if(this.css){this.queue[0].transition(this,this.options.appear,this.options.origin.css,this.options.current.css,true)}else{this.queue[0].transition(this,this.options.appear,this.options.origin.js,this.options.current.js,false)}}else{this.reset()}}for(var a=1;a<=Math.abs(c);a++){var b=(c>0?1:-1);this.current=this.current+b;if(this.current<0){this.current=this.items.length-1}else{if(this.current>this.items.length-1){this.current=0}}this.queue.push(this.items[this.current].clone(true,true).store("direction",b))}this.fireEvent("move",{delta:c});this.cycle();return this},cycle:function(){if(this.cycling||this.queue.length<=1){return this}this._cycle();return this},_cycle:function(){var f=!this.cycling;this.cycling=true;var d=this.queue.shift();var c=(this.queue.length==0);var e=d.retrieve("direction");var a=d.retrieve("direction");if(!c){var b=this.queue.shift();a=b.retrieve("direction");this.queue.push(b)}this.transitioning.push(d);if(this.css){if(!f){d.transition(this,this.options.appear,(e>=0?this.options.origin.css:this.options.destination.css),this.options.current.css,true)}if(!c){d.transition(this,this.options.disappear,this.options.current.css,(a>=0?this.options.destination.css:this.options.origin.css),true)}}else{if(!f){d.transition(this,this.options.appear,(e>=0?this.options.origin.js:this.options.destination.js),this.options.current.js,false)}if(!c){d.transition(this,this.options.disappear,this.options.current.js,(a>=0?this.options.destination.js:this.options.origin.js),false)}}if(this.queue.length==0){this.queue.push(d);this.cycling=false}else{if(f){this._cycle()}else{this._cycle.delay(this.options.flutter,this)}}return this}});